/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.GolonganPegawaiDao;
import com.portofolio.dto.GolonganPegawaiDto;
import com.portofolio.entity.GolonganPegawai;
import com.portofolio.entity.vo.GolonganPegawaiId;
import com.portofolio.exception.InfoException;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class GolonganPegawaiService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private GolonganPegawaiDao golonganPegawaiDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;
	
	@Lazy
	@Autowired
	private LanguageService languageService;

	@Transactional
	public Map<String, Object> save(GolonganPegawaiDto golonganPegawaiDto) {
		result.clear();
		GolonganPegawaiId id = new GolonganPegawaiId();
		Integer kdGolonganPegawai =getIdTerahir(GolonganPegawai.class.getSimpleName());
		id.setKdGolonganPegawai(kdGolonganPegawai);
		id.setKdProfile(getKdProfile());
		GolonganPegawai golonganPegawai = CommonUtil.findOne(golonganPegawaiDao, id);
		if (CommonUtil.isNullOrEmpty(golonganPegawai)) {
			golonganPegawai = new GolonganPegawai();
			BeanUtils.copyProperties(golonganPegawaiDto, golonganPegawai);
			golonganPegawai.setNoRec(generateUuid32());
			golonganPegawai.setVersion(1);
			golonganPegawai.setId(id);
			golonganPegawai.setNoUrut(1);
			golonganPegawai = golonganPegawaiDao.save(golonganPegawai);
			result.put("golonganPegawai", golonganPegawai);
			resultCreated();
		} else {
			throw new InfoException(languageService.getTranslateByKey("golonganPegawai.message.dataAlreadyExist"));
		}

		return result;
	}

	@Transactional
	public Map<String, Object> update(GolonganPegawaiDto golonganPegawaiDto, Integer kdGolonganPegawai, Integer version) {
		result.clear();
		GolonganPegawaiId id = new GolonganPegawaiId();
		id.setKdGolonganPegawai(kdGolonganPegawai);
		id.setKdProfile(getKdProfile());
		GolonganPegawai golonganPegawai = CommonUtil.findOne(golonganPegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(golonganPegawai)) {
			if (version < golonganPegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			BeanUtils.copyProperties(golonganPegawaiDto, golonganPegawai);
			golonganPegawai.setVersion(version);
			golonganPegawai = golonganPegawaiDao.save(golonganPegawai);
			result.put("golonganPegawai", golonganPegawai);
			resultUpdated();
		} else {
			resultNotFound();
		}

		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, String namaGolonganPegawai,boolean statusEnabled) {
		result.clear();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(namaGolonganPegawai)) {
			pageRes = golonganPegawaiDao.findAllList(getKdProfile(), statusEnabled, pageReq);
		} else {
			pageRes = golonganPegawaiDao.findAllList(getKdProfile(), namaGolonganPegawai, statusEnabled, pageReq);
		}
		result.put("golonganPegawai", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();

		return result;
	}

	
	public Map<String, Object> findByKdGolonganPegawai(Integer kdGolonganPegawai) {
		result.clear();
		result.put("golonganPegawai", golonganPegawaiDao.findByKdGolonganPegawai(getKdProfile(), kdGolonganPegawai, CONSTANT_STATUS_ENABLED_TRUE));
		resultSuccessful();
		return result;
	}

	@Transactional
	public Map<String, Object> deleteById(Integer kdGolonganPegawai, Integer version) {
		result.clear();
		GolonganPegawaiId id = new GolonganPegawaiId();
		id.setKdGolonganPegawai(kdGolonganPegawai);
		id.setKdProfile(getKdProfile());
		GolonganPegawai golonganPegawai = CommonUtil.findOne(golonganPegawaiDao, id);
		if (CommonUtil.isNotNullOrEmpty(golonganPegawai)) {
			if (version < golonganPegawai.getVersion()) {
				throw new InfoException(languageService.getTranslateByKey("global.message.transactionLocking"));
			}
			golonganPegawai.setStatusEnabled(false);
			golonganPegawai.setVersion(version);
			golonganPegawai = golonganPegawaiDao.save(golonganPegawai);
			result.put("golonganPegawai", golonganPegawai);
			resultDeleted();
		} else {
			resultNotFound();
		}

		return result;
	}

	


}
